/*
	Criar um Diretorio no LINUX 
		Exemplo: 
			/home/usuario/work/prg/
			/home/usuario/work/dbfexp/
	
	Copiar para /home/usuario/work/prg os seguintes arquivos:
		cadastro.prg  
		print_lpt.prg 
		Makefile
	
	Para compilar e linkeditar com o FlagShip, digitar apenas make
	
	Antes de executar voce deve:
		1. Ter uma impressora habilitada para o usuario.
		2. No ambiente operacional voce deve setar as seguintes variaveis:
			export FS_LPT1_OFF="lpr -Pnomedospool"
		   **** Caso voce nao tenha definido um nome para o spool entao utilize:
			export FS_LPT1_OFF="lpr"
			
			e a variavel: 
			export FS_LPT1_ON="TEMPFILE()"

	Executar o programa via ./cadastro
	Caso queira executar sem a compilacao, o seu ambiente deve ser LINUX, 
	CONECTIVA 4.0
	Copiar o executavel cadastro para o diretorio prg e executar ./cadastro
*/ 
#ifdef FlagShip	
       #INCLUDE  "fspreset.fh" // Considerar esta include para o FlagShip

       #command SET PRINTER OFF      => prtout()
       #command SET PRINTER TO LPT1: => prton("1")
       #command SET PRINTER TO LPT2: => prton("2")
       #command SET PRINTER TO LPT3: => prton("3")
       #command SET PRINTER TO LPT4: => prton("4")

#endif       
#INCLUDE  "INKEY.CH"
// fs_set("translext","ntx","sql") // Para Banco de Dados Relacional com RDD INSO

FUNCTION MAIN()
   LOCAL cScrn , cCor ,  cGoOn    :=  "Y" , nChoice 
   LOCAL cArquivo , cIndice
   LOCAL aOptions := { " Cadastro de Clientes  " , ;
   		       " Execucao Comandos SQL " , ;
		       "     Encerramento      " }
   LOCAL aOptManu := { " Inclusao  " , ;
   		       " Alteracao " , ;
   		       " Exclusao  " , ;
   		       " Consulta  " , ;
   		       " Relatorio " }
   
   PUBLIC cDir    := "..\dbfexp\"   				
   PUBLIC nCodigo     := 0         
   PUBLIC cNome       := SPACE(30) 

/* Somente para Banco de Dados Relacional com RDD INSO
extern IngresRDDNew
rddatual:=rddsetdefault("IngresRDD")

SET DATABASE TO "db_inso" GET REPLY AT conectou  
IF CONECTOU < 1
   alert("nao conectou")
   quit
endif
// FS FIM !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*/
   cArquivo := cDir+"teste.dbf" ; cIndice := cDir+"teste.ntx"
   
   IF !FILE (cArquivo)
       DbCreate ( cArquivo , {{"Codigo","N",6,0},{"Nome","C",30,0 }} )      
   ENDIF
   IF !FILE (cIndice)
       USE (cArquivo) EXCLUSIVE NEW
       INDEX ON STR(Codigo,6,0) TO (cIndice)       
       USE
   ENDIF
   
   SETCOLOR("W/BG")
   CLEAR SCREEN

   SET SCOREBOARD OFF
   SET DATE TO BRITISH
   SET CENTURY ON
   SET DELETE  ON

   @ 00,00 SAY PADC (" Inso Informatica e Servicos S/C LTDA ",80) COLOR "R+/N"
   Quadro (01,01,23,79,"( Sistema Demo )")   
   cScrn := SAVESCREEN (00,00,24,79)
   
   USE (cArquivo) ALIAS Teste INDEX (cIndice) SHARED NEW
   
   WHILE cGoOn = "Y"
      SETCOLOR("W/B")

      @ 02,02,06,27  BOX "Ŀ "

      nChoice := aChoice (03,04,07,26, aOptions)
      
      DO CASE
	 CASE nChoice == 1
	      Tabela (03,28,09,40,aOptManu)
	 CASE nChoice == 2
	      Comandos(01,01,22,78,"( Acesso a RDBMS Com Comandos SQL )")
	 OTHERWISE
	      cGoOn := "F"
	 ENDCASE
   ENDDO

   SETCOLOR("W/B")
   CLEAR SCREEN

//   DispQuadro(" Fechando o Banco de Dados - Aguarde ... ","W/B")
   INKEY(1)

   DBCLOSEALL()
   CLEAR SCREEN

RETURN NIL

FUNCTION Tabela (nT,nL,nB,nR,aOptions)
   LOCAL cGoOn := "Y" , cCor := SETCOLOR()
   LOCAL cScrn := SAVESCREEN (00,00,24,79)

   @ nT,nL,nB,nR  BOX "Ŀ "

   nChoice := aChoice (nT+1,nL+1,nB-1,nR-1, aOptions)
   SETCOLOR(cCor)
   DO CASE
      CASE nChoice == 1
	   Inclusao  (02,02,22,78,"( Inclusao de Cadastro )")
      CASE nChoice == 2
	   Alteracao (02,02,22,78,"( Alteracao de Cadastro )")
      CASE nChoice == 3
           Exclusao  (02,02,22,78,"( Exclusao de Cadastro )")
      CASE nChoice == 4
           Consulta (02,02,22,78,"( Consulta do Cadastro )")
      CASE nChoice == 5
           Relatorio (01,02,22,78,"( Relatorio do Cadastro )")
      OTHERWISE
	   cGoOn := "F"
   ENDCASE

   SETCOLOR(cCor)
   RESTSCREEN (00,00,24,79,cScrn)

RETURN .T.   

FUNCTION Alteracao (nT,nL,nB,nR,cTit)
   LOCAL lFlg  := .F. 
   LOCAL cGoOn := "Y"
      
   Tela (nT,nL,nB,nR,cTit)
   
   SELE Teste
   SET ORDER TO 1
   
   WHILE cGoOn = "Y"
         @ 24,00 SAY PADC (" ")				        COLOR ("N/N")
         @ nT+2, nL+11 GET nCodigo	PICT "999999"
         READ
         IF LASTKEY() = K_ESC
            cGoOn := "N"
            LOOP
         ENDIF
         DbSeek (STR(nCodigo,6,0))
         IF FOUND()
            cNome := Nome
            @ nT+3,nL+11 GET cNome	PICT "@!"	VALID !EMPTY(cNome)
            READ
            IF LASTKEY() = K_ESC
               LOOP
            ENDIF
            RLOCK()
            REPL Nome	WITH cNome   
            UNLOCK
            DbCommit()
            @ 24,00 SAY PADC ("Registro ALTERADO com SUCESSO",79)	COLOR ("R/N")
            inkey(1)
         ELSE
            @ 24,00 SAY PADC ("Registro NAO CADASTRADO",79)		COLOR ("R/N")
            inkey(1)
         ENDIF           
   ENDDO

RETURN lFlg

FUNCTION Inclusao (nT,nL,nB,nR,cTit)
   LOCAL lFlg := .T. , cScrn := SAVESCREEN (00,00,24,79)
   LOCAL cGoOn := "Y"
      
   Tela (nT,nL,nB,nR,cTit)
   
   SELE Teste
   SET ORDER TO 1
   
   WHILE cGoOn = "Y"
         @ 24,00 SAY PADC (" ")				        COLOR ("N/N")
         @ nT+2, nL+11 GET nCodigo	PICT "999999"
         READ
         IF LASTKEY() = K_ESC
            cGoOn := "N"
            LOOP
         ENDIF
         DbSeek (STR(nCodigo,6,0))
         IF .NOT. FOUND()
            cNome := SPACE(30)
            @ nT+3,nL+11 GET cNome	PICT "@!"	VALID !EMPTY(cNome)
            READ
            IF LASTKEY() = K_ESC
               LOOP
            ENDIF
            APPE BLAN
            RLOCK()
            REPL  Codigo WITH nCodigo ,;
            	  Nome	 WITH cNome   
            UNLOCK
            DbCommit()
            @ 24,00 SAY PADC ("Registro INCLUIDO com SUCESSO",79)	COLOR ("R/N")
            inkey(1)
         ELSE
            @ 24,00 SAY PADC ("Registro JA CADASTRADO",79)		COLOR ("R/N")
            @ nT+3,nL+11 SAY cNome 	PICT "@!"
            inkey(1)
         ENDIF           
   ENDDO

   RESTSCREEN (00,00,24,79,cScrn)

RETURN lFlg

FUNCTION Exclusao (nT,nL,nB,nR,cTit)
   LOCAL lFlg := .T. , cScrn := SAVESCREEN (00,00,24,79)
   LOCAL cGoOn := "Y", cOpcao := "N"
   
   Tela (nT,nL,nB,nR,cTit)
   
   SELE Teste
   SET ORDER TO 1
   
   WHILE cGoOn = "Y"
         @ 24,00 SAY PADC (" ")				        COLOR ("N/N")
         @ nT+2, nL+11 GET nCodigo	PICT "999999"
         READ
         IF LASTKEY() = K_ESC
            cGoOn := "N"
            LOOP
         ENDIF
         DbSeek (STR(nCodigo,6,0))
         IF FOUND()
            @ nT+3,nL+11 SAY Nome	PICT "@!"	
            @ 24,00 SAY PADC ("Exclui o Registro ? (S/N).:   ",79)
            @ 24,52 GET cOpcao PICT "@!"	VALID (cOpcao$"SN")
            READ
            IF LASTKEY() = K_ESC
               LOOP
            ENDIF
            IF cOpcao = "S" 
               RLOCK()
               DELE
               UNLOCK
               DbCommit()  
               @ 24,00 SAY PADC ("Registro EXCLUIDO com SUCESSO",79)	COLOR ("R/N")
               inkey(1)
            ENDIF   
         ELSE
            @ 24,00 SAY PADC ("Registro JA CADASTRADO",79)		COLOR ("R/N")
            @ nT+3,nL+11 SAY cNome 	PICT "@!"
            inkey(1)
         ENDIF           
   ENDDO

   RESTSCREEN (00,00,24,79,cScrn)

RETURN lFlg

FUNCTION Consulta(nT,nL,nB,nR,cTit)
   LOCAL lFlg := .T. , cScrn := SAVESCREEN (00,00,24,79)

   Tela (nT,nL,nB,nR,cTit)

   SELE Teste
   SET ORDER TO 1
   BROWSE(nT+2,nL,nB,nR)

   RESTSCREEN (00,00,24,79,cScrn)

RETURN lFlg

FUNCTION Relatorio (nT,nL,nB,nR,cTit)
   LOCAL lFlg  := .T. , nFolha := 0 , nCont := 1
   LOCAL cScrn := SAVESCREEN (00,00,24,79) 
   LOCAL cArqTxt := "tmp.txt" , nInd   := 1  
   LOCAL aTemp   := {}
   
   IF FILE (  cArqTxt )
      FERASE ( cArqTxt )
   ENDIF

   Imprime:=Alert("Envia o relatorio para impressora ?",{"SIM","NAO"})      
   if Imprime=1
   	SET PRINTER TO LPT1:
   	SET DEVICE  TO PRINT
   	SET PRINTER ON
   else
   	SET DEVICE  TO PRINT
   	SET PRINTER TO ( cArqTxt )
   endif
      
   nFolha := ImprimeCab ( nFolha )
   nCont  := 5
   
   SELE Teste
   SET ORDER TO 1
   dbgotop()
   WHILE .NOT.  EOF()
         IF nCont > 50
            nFolha := ImprimeCab ( nFolha )
            nCont  := 5
         ENDIF
         @ nCont, 01 SAY Codigo 	PICT "999999"
         @ nCont, 08 SAY Nome		PICT "@!"
         nCont := nCont + 1
         DbSkip()  
   ENDDO
   dbgotop()
   EJECT
   if Imprime=1
   	SET DEVICE TO SCREEN
   	SET PRINT TO
   	SET PRINT OFF
   else
   	SET DEVICE TO SCREEN
   	SET PRINTER TO

	cString := MemoRead ( cArqTxt )
   
   	SETCOLOR("W+/B")
   	MemoEdit (cString , nT+1,nL,nB,nR,.F.)
				       
   	IF ALERT("Imprime o Relatorio ? ", {"NAO","SIM"})=2
   		#ifdef FlagShip
			RUN( "lpr " + cArqTxt )		// Para o FlagShip Linux com Impressao Normal      
		     // RUN( "rpr " + cArqTxt )		// Para o FlagShip Linux com Impressao Remota       
   		#else
			TYPE (cArqTxt) TO PRINTER	// Para o Clipper  DOS
   		#endif
   	ENDIF
   endif
   RESTSCREEN (00,00,24,79,cScrn)
   
RETURN lFlg

FUNCTION ImprimeCab(nFol)
   LOCAL nFolha := nFol + 1
   LOCAL nLin   := 1
   
   @ nLin, 01 SAY "Data.: "
   @ nLin, 08 SAY DATE()
   @ nLin, 25 SAY "Relacao de Cadastro" 
   @ nLin, 60 SAY "Folha.: "
   @ nLin, 68 SAY nFolha PICT "99,999"
   nLin := nLin + 2
   @ nLin, 01 SAY "Codigo                Nome "

RETURN nFolha

FUNCTION Comandos (nT,nL,nB,nR,cTit)
alert(" COMANDOS SQL Somente para Banco de Dados RELACIONAL ")

/* Esta Funcao  para execuo de comandos SQL para Banco de Dados Relacional 
   Todas as funcoes do Clipper podem ser mantidas, que o RDD INSO converte 
   automaticamente.
   Alem disso o RDD, permite inserir no fonte QUALQUER comando SQL, conforme 
   exemplo abaixo
   
   LOCAL cSql , cScrn := SAVESCREEN (00,00,24,79)
   LOCAL cCmd01 := SPACE(76) , cCmd02 := SPACE(76) 
   LOCAL cCmd03 := SPACE(76) , cCmd04 := SPACE(76) 
   LOCAL cCmd05 := SPACE(76) , cCmd06 := SPACE(76) 
   LOCAL cCmd07 := SPACE(76) , cCmd08 := SPACE(76) 
   LOCAL nInicio := 0        , nTempo := 0
   LOCAL cLoop   := "S"
   LOCAL cLAlias := ALIAS()
      
   Quadro(nT,nL-1,nB+1,nR+1,cTit)
   
   @ nT+01,nL+1 SAY PADC ( " Informe UM Comando SQL e Tecle <ENTER> ",77)
   @ nT+02,nL+1 SAY " Tempo de Processamento em Segundos.:       "
   
   WHILE cLoop = "S"
      @ nT+03,nL+1 GET cCmd01 PICT "@!" VALID !EMPTY(cCmd01)
      @ nT+04,nL+1 GET cCmd02 PICT "@!"
      @ nT+05,nL+1 GET cCmd03 PICT "@!"
      @ nT+06,nL+1 GET cCmd04 PICT "@!"
      @ nT+07,nL+1 GET cCmd05 PICT "@!"
      @ nT+08,nL+1 GET cCmd06 PICT "@!"
      @ nT+09,nL+1 GET cCmd07 PICT "@!"
      @ nT+10,nL+1 GET cCmd08 PICT "@!"
      READ 
      IF LASTKEY() <> K_ESC
         nInicio := SECONDS()
         cSql := ALLTRIM(cCmd01)+ALLTRIM(cCmd02)+ALLTRIM(cCmd03)+ALLTRIM(cCmd04)+;
     	         ALLTRIM(cCmd05)+ALLTRIM(cCmd06)+ALLTRIM(cCmd07)+ALLTRIM(cCmd08)

         ExecSql cSql ALIAS "Temp"
         nTempo := SECONDS() - nInicio
         @ nT+02,nL+38 SAY nTempo  	PICT "999,999"
	 ALERT ( " Aperte Qualquer Tecla para Continuar " )
         IF SUBSTR(cSql,1,4) = "SELE"
            browse()
         ENDIF
         SELE Temp
         USE
   	 cCmd01 := SPACE(76) ; cCmd02 := SPACE(76) 
   	 cCmd03 := SPACE(76) ; cCmd04 := SPACE(76) 
   	 cCmd05 := SPACE(76) ; cCmd06 := SPACE(76) 
  	 cCmd07 := SPACE(76) ; cCmd08 := SPACE(76) 
      ELSE
         cLoop := "F"   
      ENDIF
   ENDDO      
   SELE ( cLAlias )
   RESTSCREEN (00,00,24,79,cScrn)
*/
RETURN NIL

FUNCTION Tela(nT,nL,nB,nR,cTit)
   LOCAL cCor := SETCOLOR()

   SETCOLOR("BG/BG")   
   SCROLL (nT,nL,nB,nR,0)
   SETCOLOR("W/BG")   
   @ nT  ,nL+1 SAY (cTit)					COLOR ("GB+/BG")
   @ nT+2,nL+1 SAY " Codigo.:                                 " COLOR ("W+/BG")
   @ nT+3,nL+1 SAY "   Nome.:                                 " COLOR ("W+/BG")
   @ nT+5,02,nT+5,78  BOX "Ŀ " 				COLOR ("R+/BG")

RETURN .T.

FUNCTION Quadro (nT,nL,nB,nR,cTit)
   LOCAL nLeft := 0 , cCor := SETCOLOR()
   
   SETCOLOR("RG+/BG")
   nLeft := (80 - LEN(cTit)) / 2 
   @ nT,nL,nB,nR  BOX "Ŀ "       COLOR ("R+/BG")
   @ nT,nLeft SAY PADC (cTit,LEN(cTit)) COLOR ("RG+/BG")
   @ nT,62 SAY "Data.: "                COLOR ("RG+/BG")
   @ nT,69 SAY DATE()                   COLOR ("RG+/BG")
   @ nB,03 SAY "(<ESC> = Retorna)"      COLOR ("RG+/BG")

RETURN NIL
